# -*- coding: utf-8 -*-
"""
Created on Sat Nov 08 14:57:35 2014

Kleine GUI zum Abspeichern eines Screenshots vom DSO-Bildschirm ueber USB.

@author: Sven
"""

from DS1074Z import *
import wx
import shutil


class MainFrame(wx.Frame):
    '''Bedienoberfläche'''
    def __init__(self):
        '''Konstruktor: GUI einrichten und nach Oszis suchen'''
        wx.Frame.__init__(self, None, -1, u'Rigol DS1074Z Screenshot', 
                          style=wx.MINIMIZE_BOX  | wx.SYSTEM_MENU | 
                          wx.CAPTION | wx.CLOSE_BOX)                            # Fenser erzeugen
        self.panel = wx.Panel(self, wx.ID_ANY, wx.DefaultPosition, 
                              wx.DefaultSize, wx.TAB_TRAVERSAL )
        x_size = 950                    
        y_size = 540                      
        self.SetSize((x_size,y_size))
        self.DSO = 0
        self.menubar = wx.MenuBar()
        self.DeviceMenu = wx.Menu()
        dev_list = get_device_list()

        for i in dev_list:
            item = self.DeviceMenu.AppendItem( wx.MenuItem(self.DeviceMenu, -1, i, 
                                                           kind=wx.ITEM_RADIO) )
            self.Bind(wx.EVT_MENU, self.connect, item)

        self.menubar.Append(self.DeviceMenu, 'Devices')
        self.SetMenuBar(self.menubar)

        
        png = wx.Image('temp.png', wx.BITMAP_TYPE_ANY).ConvertToBitmap()
        self.image = wx.StaticBitmap(self.panel, -1, png, (10, 5), (png.GetWidth(), png.GetHeight()))        
        
        self.Save = wx.Button(self.panel, -1, 'Save as', pos=(840, 450))
        self.Shot = wx.Button(self.panel, -1, 'Screenshot', pos=(840, 410))
        
        self.Bind(wx.EVT_BUTTON, self.save, self.Save)
        self.Bind(wx.EVT_BUTTON, self.shot, self.Shot)


    def connect(self, event):
        '''Stellt bei Auswahl eines Menu-Items die Verbindung her'''
        item = self.GetMenuBar().FindItemById(event.GetId())
        text = item.GetText()
        self.DSO = DS1074Z(text)
        event.Skip()

    def shot(self, event):
        '''Macht einen Screenshot'''
        self.DSO.screenshot('','temp')
        png = wx.Image('temp.png', wx.BITMAP_TYPE_ANY).ConvertToBitmap()
        self.image = wx.StaticBitmap(self.panel, -1, png, (10, 5), (png.GetWidth(), png.GetHeight()))    
        self.panel.Update()
        self.panel.Refresh()
        event.Skip()
        
    def save(self, event):
        '''Speichert Screenshot'''
        saveFileDialog = wx.FileDialog(self, "Save As", "", "", 
                                      "PNG (*.png)|*.png", 
                                      wx.FD_SAVE | wx.FD_OVERWRITE_PROMPT)
        if saveFileDialog.ShowModal()==wx.ID_OK:    
            shutil.copy2('temp.png', saveFileDialog.GetPath())
        saveFileDialog.Destroy()
        
        event.Skip()

#########################
#   Fenster erzeugen    #
#########################

if __name__ == '__main__':
    app = wx.PySimpleApp()
    app.frame = MainFrame()
    app.frame.Show()
    app.MainLoop()